/*
 * Matrix allocation and freeing Functions.
 *
 * allocmatrix.c
 *
 * Peter Janssen 
 *
 */
#include <stdlib.h>
#include "geom.h"
#include "allocmatrix.h"


void **allocMatrix(size,  sizeY,  sizeX)
size_t size, sizeY, sizeX;
{
void   **Matrix, **M;
size_t   y;

    Matrix = (void *) share_malloc(sizeY * (sizeof(void *)));
    size *= sizeX;
    for (y = sizeY, M = Matrix; y > 0; y--, M++) {
        *M = share_malloc(size);
    }
    return Matrix;
}

void freeMatrix(Matrix, sizeY)
void    **Matrix;
size_t    sizeY;
{
    void **M;

    for (M=Matrix; sizeY>0; sizeY--, M++) free(*M);
    free(Matrix);
}
